﻿using System;
using System.Windows.Forms;

namespace DirtyFormulaNotCalculating
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraCalcManager.RegisterUserDefinedFunction(new CurrentTime());
        }

        private void btnRecalc_Click(object sender, System.EventArgs e)
        {
            ultraCalcManager.ReCalc();
        }

        private void btnDirtyAllFormulas_Click(object sender, System.EventArgs e)
        {
            ultraCalcManager.DirtyAllFormulas();
        }
    }

    public class CurrentTime : Infragistics.Win.CalcEngine.UltraCalcFunction
    {
        protected override Infragistics.Win.CalcEngine.UltraCalcValue Evaluate(Infragistics.Win.CalcEngine.UltraCalcNumberStack numberStack, int argumentCount)
        {
            return new Infragistics.Win.CalcEngine.UltraCalcValue(DateTime.Now);
        }

        public override bool IsAlwaysDirty
        {
            get
            {
                return true;
            }
        }

        public override string Name
        {
            get { return "CurrentTime"; }
        }

        public override string[] ArgDescriptors
        {
            get { return new string[] { }; }
        }

        public override string[] ArgList
        {
            get { return new string[] { }; }
        }

        public override string Category
        {
            get { return "Custom"; }
        }

        public override string Description
        {
            get { return "Returns the current datetime"; }
        }

        public override int MinArgs
        {
            get { return 0; }
        }

        public override int MaxArgs
        {
            get { return 0; }
        }
    }
}
